//: Playground - noun: a place where people can play

import Cocoa

var str = "Hello, playground"

enum Happiness1 {
    case Sad
    case Happy
}

var mood1 = Happiness1.Sad
if mood1 == Happiness1.Sad {
    Swift.print("1. I'm quite sad today!")
}

// ---------------------------------------------------------------------

enum Happiness2 {
    case Sad
    case Happy(ofGrade: Int)
}

var mood2 = Happiness2.Sad
//if mood2 == Happiness2.Sad {
//    Swift.print("2. I'm quite sad today!")
//}

// ---------------------------------------------------------------------

enum Happiness3: Equatable {
    case Sad
    case Happy(ofGrade: Int)
    
    static func == (lhs: Happiness3, rhs: Happiness3) -> Bool {
        switch lhs {                    // look at the left hand side
        case .Sad:                      // its sad
            switch rhs {                // and what's on the right?
            case .Sad:                  // also sad
                return true
            default:                    // something else
                break
            }
        case .Happy(let lgrade):        // its happy with some grade
            switch rhs {                // look on the right hand side
            case .Happy(let rgrade):    // also happy
                return lgrade == rgrade // return true if grades are the same
            default:
                break
            }
        }
        return false                    // otherwise return false
    }
    
    func isSimilar(toHappiness rhs: Happiness3) -> Bool {
        switch self {                   // look at ourself
        case .Sad:                      // its sad
            switch rhs {                // and what's on the right?
            case .Sad:                  // also sad
                return true
            default:                    // something else
                break
            }
        case .Happy(_):                 // its happy, grade is not interesting
            switch rhs {                // look on the right hand side
            case .Happy(_):             // also happy, grade is not interesting
                return true             // return true regardless of grades
            default:
                break
            }
        }
        return false                    // otherwise return false
    }
}

var mood3 = Happiness3.Sad
if mood3 == Happiness3.Sad {
    Swift.print("3. I'm quite sad today!")
}

if mood3 != Happiness3.Happy(ofGrade: 5) {
    Swift.print("3. Not that happy today!")
}

mood3 = Happiness3.Happy(ofGrade: 5)
if mood3.isSimilar(toHappiness: Happiness3.Happy(ofGrade: 0)) {
    Swift.print("3. Somewhat happy for the time being!")
}

// ---------------------------------------------------------------------

enum Happiness4: Equatable {
    case Sad
    case Happy(ofGrade: Int)
    
    static func == (lhs: Happiness4, rhs: Happiness4) -> Bool {
        switch (lhs, rhs) {             // look at both sides simultaneously
        case (.Sad, .Sad): return true  // both are sad
                                        // both happy: return true if grades are same
        case (.Happy(let lgrade), .Happy(let rgrade)): return lgrade == rgrade
                                        // for all other comobinations: return false
        case (.Sad, _),
             (.Happy(_), _): return false
        }
    }

    func isSimilar(toHappiness rhs: Happiness4) -> Bool {
        switch (self, rhs) {            // look at both sides simultaneously
        case (.Sad, .Sad): return true  // both are sad
                                        // both happy: return true regardeless of grades
        case (.Happy(_), .Happy(_)): return true
                                        // for all other comobinations: return false
        case (.Sad, _),
             (.Happy(_), _): return false
        }
    }
}

var mood4 = Happiness4.Sad
if mood4 == Happiness4.Sad {
    Swift.print("4. I'm quite sad today!")
}
